## $Id: test_document.py 12292 2014-12-22 07:21:46Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for skeleton documents.
"""
from zope.interface.verify import verifyClass, verifyObject
from zope.component import createObject
from waeup.ikoba.documents.container import DocumentsContainer

from ikobacustom.skeleton.testing import (FunctionalLayer, FunctionalTestCase)
from ikobacustom.skeleton.documents.document import SkeletonDocument
from ikobacustom.skeleton.documents.interfaces import ISkeletonDocument

class SkeletonDocumentTestCase(FunctionalTestCase):

    layer = FunctionalLayer

    def test_interfaces(self):
        # Make sure the correct interfaces are implemented.
        self.assertTrue(
            verifyClass(
                ISkeletonDocument, SkeletonDocument)
            )
        self.assertTrue(
            verifyObject(
                ISkeletonDocument, SkeletonDocument())
            )
        return

    def test_addSkeletonDocument(self):
        container = DocumentsContainer()
        document = createObject(u'waeup.SkeletonDocument')
        document.document_id = u'DOC1'
        container.addDocument(document)
        self.assertRaises(TypeError, container.addDocument, object())
        self.assertEqual(document.document_id, 'DOC1')
        self.assertEqual(container['DOC1'], document)
        return
